%define GITDATE        20180702
%define GITCOMMIT      9b7ab2f

%global debug_package %{nil}

Name:       SLOF
Version:    %{GITDATE}
Release:    4.git%{GITCOMMIT}%{?dist}
Summary:    Slimline Open Firmware
Group:      Applications/Emulators
License:    BSD
URL:        http://www.openfirmware.info/SLOF

Source0: https://github.com/aik/SLOF/archive/qemu-slof-20180702.tar.gz

Patch0002: 0002-make.rules-Compile-SLOF-with-fno-asynchronous-unwind.patch
Patch0003: 0003-romfs-tools-Remove-superfluous-union-around-the-rom-.patch
Patch0004: 0004-romfs-tools-Silence-GCC-8.1-compiler-warning-with-FL.patch
Patch0005: 0005-romfs-tools-Silence-more-compiler-warnings-with-GCC-.patch
Patch0006: 0006-board-qemu-slof-vio-vscsi-Scan-up-to-64-SCSI-IDs.patch
Patch0007: 0007-usb-storage-Invert-the-logic-of-the-IF-statements.patch
Patch0008: 0008-usb-storage-Implement-block-write-support.patch
# For bz#1663160 - SLOF does not scan disks with channel id is not 0 on the spapr-vscsi adaptor
Patch9: slof-vio-vscsi-Support-multiple-channels-buses.patch

BuildArch: noarch
ExclusiveArch: %{power64}

BuildRequires:  binutils
BuildRequires:  perl(Data::Dumper)

%description
Slimline Open Firmware (SLOF) is initialization and boot source code
based on the IEEE-1275 (Open Firmware) standard, developed by
engineers of the IBM Corporation.

The SLOF source code provides illustrates what's needed to initialize
and boot Linux or a hypervisor on the industry Open Firmware boot
standard.

Note that you normally wouldn't need to install this package
separately.  It is a dependency of qemu-system-ppc64.

%prep
%setup -q -n SLOF-qemu-slof-%{GITDATE}

%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch9 -p1

%build
export CROSS=""

# Workaround for problems on the TPS machines.  They have a
# environment variable called "RELEASE" which somehow confuses the
# SLOF Makefiles which also use a variable named RELEASE.
unset RELEASE

make qemu %{?_smp_mflags} V=2

%install
mkdir -p $RPM_BUILD_ROOT%{_datadir}/qemu-kvm
install -c -m 0644 boot_rom.bin $RPM_BUILD_ROOT%{_datadir}/qemu-kvm/slof.bin

%files
%doc LICENSE
%doc README
%dir %{_datadir}/qemu-kvm
%{_datadir}/qemu-kvm/slof.bin

%changelog
* Mon Jul 01 2019 Danilo de Paula <ddepaula@redhat.com> - 20180702-4.git9b7ab2f
- Rebuild all virt packages to fix RHEL's upgrade path
- Resolves: rhbz#1725959
  (Ensure modular RPM upgrade path [rhel-av-8.0.1])

* Thu Jan 24 2019 Danilo Cesar Lemes de Paula <ddepaula@redhat.com> - 20180702-3.git9b7ab2f.el8
- slof-vio-vscsi-Support-multiple-channels-buses.patch [bz#1663160]
- Resolves: bz#1663160
  (SLOF does not scan disks with channel id is not 0 on the spapr-vscsi adaptor)

* Thu Jan 17 2019 Miroslav Rezanina <mrezanin@redhat.com> - 20180702-1.git9b7ab2f
- Rebase to 20180702 [bz#1666132]
- Resolves: bz#1666132
  (Rebase SLOF for RHEL-AV release in virt:8.0.0 stream)

* Fri Jan 04 2019 Danilo Cesar Lemes de Paula <ddepaula@redhat.com> - 20171214-5.gitfa98132.el8
- slof-board-qemu-slof-vio-vscsi-Scan-up-to-64-SCSI-IDs.patch [bz#1655649]
- slof-usb-storage-Invert-the-logic-of-the-IF-statements.patch [bz#1654196]
- slof-usb-storage-Implement-block-write-support.patch [bz#1654196]
- Resolves: bz#1654196
  ([RHEL8.0][USB]  guest failed to boot from emulated usb-storage)
- Resolves: bz#1655649
  (RHEL8.0 - ISST-LTE:KVM:Failed to boot the guest from cdrom drive)

* Fri Aug 10 2018 Danilo Cesar Lemes de Paula <ddepaula@redhat.com> - 20171214-4.gitfa98132.el8
- slof-libelf-Add-REL32-to-the-list-of-ignored-relocations.patch [bz#1613619]
- slof-Fix-bad-assembler-statements-for-compiling-with-gcc-.patch [bz#1613619]
- slof-make.rules-Compile-SLOF-with-fno-asynchronous-unwind.patch [bz#1613619]
- slof-romfs-tools-Remove-superfluous-union-around-the-rom-.patch [bz#1613619]
- slof-romfs-tools-Silence-GCC-8.1-compiler-warning-with-FL.patch [bz#1613619]
- slof-romfs-tools-Silence-more-compiler-warnings-with-GCC-.patch [bz#1613619]
- Resolves: bz#1613619
  ([RHEL8.0]Console contains error message (ERROR: Unhandled relocation (A) type 26) after continuing a guest)

* Wed Jul 11 2018 Danilo Cesar Lemes de Paula - 20171214-3.gitfa98132.el8
- Release to RHEL-8.0
